diff --git a/src/odbc/unittests/putdata.c b/src/odbc/unittests/putdata.c
index b199b9d..a9d3878 100644
--- a/src/odbc/unittests/putdata.c
+++ b/src/odbc/unittests/putdata.c
@@ -2,7 +2,7 @@
 
 /* Test for SQLPutData */
 
-static char software_version[] = "$Id: putdata.c,v 1.9 2004/10/28 13:16:18 freddy77 Exp $";
+static char software_version[] = "$Id: putdata.c,v 1.10 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static const char test_text[] =
@@ -25,9 +25,7 @@ main(int argc, char *argv[])
 	/* create table to hold data */
 	Command(Statement, "CREATE TABLE #putdata (c TEXT NULL, b IMAGE NULL)");
 
-	if (SQLBindParameter(Statement, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_LONGVARCHAR, 0, 0, (SQLPOINTER) 123, 0, &ind) !=
-	    SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to bind output parameter");
+	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_LONGVARCHAR, 0, 0, (SQLPOINTER) 123, 0, &ind));
 	/* length required */
 	ind = SQL_LEN_DATA_AT_EXEC(len);
 
@@ -35,8 +33,7 @@ main(int argc, char *argv[])
 	 * test for char 
 	 */
 
-	if (SQLPrepare(Statement, (SQLCHAR *) "INSERT INTO #putdata(c) VALUES(?)", SQL_NTS) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to prepare statement");
+	CHK(SQLPrepare, (Statement, (SQLCHAR *) "INSERT INTO #putdata(c) VALUES(?)", SQL_NTS));
 
 	if (SQLExecute(Statement) != SQL_NEED_DATA)
 		ODBC_REPORT_ERROR("Wrong result executing statement");
@@ -57,8 +54,7 @@ main(int argc, char *argv[])
 		p += n;
 		n *= 2;
 	}
-	if (SQLParamData(Statement, &ptr) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Wrong result from SQLParamData");
+	CHK(SQLParamData, (Statement, &ptr));
 
 	if (SQLParamData(Statement, &ptr) != SQL_ERROR)
 		ODBC_REPORT_ERROR("Wrong result from SQLParamData");
@@ -74,13 +70,10 @@ main(int argc, char *argv[])
 	 * test for binary 
 	 */
 
-	if (SQLBindParameter(Statement, 1, SQL_PARAM_INPUT, SQL_C_BINARY, SQL_LONGVARBINARY, 0, 0, (SQLPOINTER) 4567, 0, &ind) !=
-	    SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to bind output parameter");
+	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, SQL_C_BINARY, SQL_LONGVARBINARY, 0, 0, (SQLPOINTER) 4567, 0, &ind));
 	ind = SQL_LEN_DATA_AT_EXEC(254);
 
-	if (SQLPrepare(Statement, (SQLCHAR *) "UPDATE #putdata SET b = ?", SQL_NTS) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to prepare statement");
+	CHK(SQLPrepare, (Statement, (SQLCHAR *) "UPDATE #putdata SET b = ?", SQL_NTS));
 
 	if (SQLExecute(Statement) != SQL_NEED_DATA)
 		ODBC_REPORT_ERROR("Wrong result executing statement");
@@ -96,13 +89,11 @@ main(int argc, char *argv[])
 
 		if (l < n)
 			n = l;
-		if (SQLPutData(Statement, (char *) p, n) != SQL_SUCCESS)
-			ODBC_REPORT_ERROR("Wrong result from SQLPutData");
+		CHK(SQLPutData, (Statement, (char *) p, n));
 		pb += n;
 		n *= 2;
 	}
-	if (SQLParamData(Statement, &ptr) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Wrong result from SQLParamData");
+	CHK(SQLParamData, (Statement, &ptr));
 
 	if (SQLParamData(Statement, &ptr) != SQL_ERROR)
 		ODBC_REPORT_ERROR("Wrong result from SQLParamData");
@@ -112,14 +103,11 @@ main(int argc, char *argv[])
 
 
 	/* test len == 0 case from ML */
-	if (SQLFreeStmt(Statement, SQL_RESET_PARAMS) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("SQLFreeStmt error");
+	CHK(SQLFreeStmt, (Statement, SQL_RESET_PARAMS));
 
-	if (SQLPrepare(Statement, (SQLCHAR *) "INSERT INTO #putdata(c) VALUES(?)", SQL_NTS) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to prepare statement");
+	CHK(SQLPrepare, (Statement, (SQLCHAR *) "INSERT INTO #putdata(c) VALUES(?)", SQL_NTS));
 
-	if (SQLBindParameter(Statement, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_LONGVARCHAR, 0, 0, (PTR) 2, 0, &ind) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("SQLBindParameter error");
+	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_LONGVARCHAR, 0, 0, (PTR) 2, 0, &ind));
 
 	ind = SQL_LEN_DATA_AT_EXEC(0);
 
diff --git a/src/odbc/unittests/raiserror.c b/src/odbc/unittests/raiserror.c
index 94bb486..76fd66f 100644
--- a/src/odbc/unittests/raiserror.c
+++ b/src/odbc/unittests/raiserror.c
@@ -4,7 +4,7 @@
 
 /* TODO add support for Sybase */
 
-static char software_version[] = "$Id: raiserror.c,v 1.19 2007/11/26 06:25:11 freddy77 Exp $";
+static char software_version[] = "$Id: raiserror.c,v 1.20 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #define SP_TEXT "{?=call #tmp1(?,?,?)}"
@@ -153,14 +153,10 @@ Test(int level)
 	SQLBindParameter(Statement, 4, SQL_PARAM_OUTPUT, SQL_C_CHAR, SQL_VARCHAR, OUTSTRING_LEN, 0, OutString, OUTSTRING_LEN,
 			 &cbOutString);
 
-	result = SQLExecute(Statement);
-
-	if (result != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("query should success");
+	CHK(SQLExecute, (Statement));
 
 	CheckData("");
-	if (SQLFetch(Statement) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("SQLFetch returned failure");
+	CHK(SQLFetch, (Statement));
 	CheckData("Here is the first row");
 
 	result = SQLFetch(Statement);
@@ -221,8 +217,7 @@ Test(int level)
 	CheckReturnCode(result, INVALID_RETURN);
 
 	CheckData("");
-	if (SQLFetch(Statement) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("SQLFetch returned failure");
+	CHK(SQLFetch, (Statement));
 	CheckData("Here is the last row");
 
 	if (SQLFetch(Statement) != SQL_NO_DATA)
diff --git a/src/odbc/unittests/rebindpar.c b/src/odbc/unittests/rebindpar.c
index d8f0c21..d814b1c 100644
--- a/src/odbc/unittests/rebindpar.c
+++ b/src/odbc/unittests/rebindpar.c
@@ -2,7 +2,7 @@
 
 /* Test for executing SQLExecute and rebinding parameters */
 
-static char software_version[] = "$Id: rebindpar.c,v 1.6 2004/12/01 13:11:35 freddy77 Exp $";
+static char software_version[] = "$Id: rebindpar.c,v 1.7 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void
@@ -13,16 +13,15 @@ TestInsert(HSTMT stmt, char *buf)
 	char sql[200];
 
 	/* insert some data and test success */
-	if (SQLBindParameter(stmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, l, 0, buf, l, &ind) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to bind");
+	CHK(SQLBindParameter, (stmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, l, 0, buf, l, &ind));
 
 	ind = l;
-	if (SQLExecute(stmt) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to execute");
+	CHK(SQLExecute, (stmt));
 
 	sprintf(sql, "SELECT 1 FROM #tmp1 WHERE c = '%s'", buf);
 	Command(Statement, sql);
-	if (SQLFetch(Statement) != SQL_SUCCESS || SQLFetch(Statement) != SQL_NO_DATA || SQLMoreResults(Statement) != SQL_NO_DATA) {
+	CHK(SQLFetch, (Statement));
+	if (SQLFetch(Statement) != SQL_NO_DATA || SQLMoreResults(Statement) != SQL_NO_DATA) {
 		fprintf(stderr, "One row expected!\n");
 		exit(1);
 	}
@@ -43,15 +42,12 @@ Test(int prebind)
 
 	Command(Statement, "DELETE FROM #tmp1");
 
-	if (SQLAllocStmt(Connection, &stmt) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to allocate statement");
+	CHK(SQLAllocStmt, (Connection, &stmt));
 
 	if (prebind)
-		if (SQLBindParameter(stmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, 1, 0, buf, 1, &ind) != SQL_SUCCESS)
-			ODBC_REPORT_ERROR("Unable to bind");
+		CHK(SQLBindParameter, (stmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, 1, 0, buf, 1, &ind));
 
-	if (SQLPrepare(stmt, (SQLCHAR *) "INSERT INTO #tmp1(c) VALUES(?)", SQL_NTS) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to prepare statement");
+	CHK(SQLPrepare, (stmt, (SQLCHAR *) "INSERT INTO #tmp1(c) VALUES(?)", SQL_NTS));
 
 	/* try to insert al empty string, should not fail */
 	/* NOTE this is currently the only test for insert a empty string using rpc */
@@ -61,8 +57,7 @@ Test(int prebind)
 	TestInsert(stmt, "bb");
 	TestInsert(stmt, buf);
 
-	if (SQLFreeStmt(stmt, SQL_DROP) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to free statement");
+	CHK(SQLFreeStmt, (stmt, SQL_DROP));
 }
 
 int
diff --git a/src/odbc/unittests/scroll.c b/src/odbc/unittests/scroll.c
index 9ba8e5f..f3ff03f 100644
--- a/src/odbc/unittests/scroll.c
+++ b/src/odbc/unittests/scroll.c
@@ -2,13 +2,9 @@
 
 /* Test cursors */
 
-static char software_version[] = "$Id: scroll.c,v 1.6 2007/11/26 06:25:11 freddy77 Exp $";
+static char software_version[] = "$Id: scroll.c,v 1.7 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
-#define CHK(func,params) \
-	if (func params != SQL_SUCCESS) \
-		ODBC_REPORT_ERROR(#func)
-
 int
 main(int argc, char *argv[])
 {
diff --git a/src/odbc/unittests/t0001.c b/src/odbc/unittests/t0001.c
index 399e30c..6ca6c8d 100644
--- a/src/odbc/unittests/t0001.c
+++ b/src/odbc/unittests/t0001.c
@@ -1,6 +1,6 @@
 #include "common.h"
 
-static char software_version[] = "$Id: t0001.c,v 1.14 2004/10/28 13:16:18 freddy77 Exp $";
+static char software_version[] = "$Id: t0001.c,v 1.15 2008/01/29 14:30:49 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -24,40 +24,23 @@ main(int argc, char *argv[])
 		"col1 varchar(30) not null,"
 		"col2 int not null,"
 		"col3 float not null," "col4 numeric(18,6) not null," "col5 datetime not null," "col6 text not null)";
-	if (CommandWithResult(Statement, command) != SQL_SUCCESS) {
-		printf("Unable to execute statement\n");
-		CheckReturn();
-		exit(1);
-	}
+	CHK(CommandWithResult, (Statement, command));
 
 	command = "insert #odbctestdata values ("
 		"'ABCDEFGHIJKLMNOP',"
 		"123456," "1234.56," "123456.78," "'Sep 11 2001 10:00AM'," "'just to check returned length...')";
-	if (CommandWithResult(Statement, command) != SQL_SUCCESS) {
-		printf("Unable to execute statement\n");
-		CheckReturn();
-		exit(1);
-	}
+	CHK(CommandWithResult, (Statement, command));
 
-	if (CommandWithResult(Statement, "select * from #odbctestdata") != SQL_SUCCESS) {
-		printf("Unable to execute statement\n");
-		CheckReturn();
-		exit(1);
-	}
+	CHK(CommandWithResult, (Statement, "select * from #odbctestdata"));
 
 	res = SQLFetch(Statement);
 	if (res != SQL_SUCCESS && res != SQL_SUCCESS_WITH_INFO) {
-		printf("Unable to fetch row\n");
+		fprintf(stderr, "Unable to fetch row\n");
 		CheckReturn();
-		exit(1);
 	}
 
 	for (i = 1; i <= 6; i++) {
-		if (SQLGetData(Statement, i, SQL_C_CHAR, output, sizeof(output), &cnamesize) != SQL_SUCCESS) {
-			printf("Unable to get data col %d\n", i);
-			CheckReturn();
-			exit(1);
-		}
+		CHK(SQLGetData, (Statement, i, SQL_C_CHAR, output, sizeof(output), &cnamesize));
 
 		printf("output data >%s< len_or_ind = %d\n", output, (int) cnamesize);
 		if (cnamesize != strlen((char *) output))
@@ -66,23 +49,17 @@ main(int argc, char *argv[])
 
 	res = SQLFetch(Statement);
 	if (res != SQL_NO_DATA) {
-		printf("Unable to fetch row\n");
+		fprintf(stderr, "Unable to fetch row\n");
 		CheckReturn();
-		exit(1);
 	}
 
 	res = SQLCloseCursor(Statement);
 	if (!SQL_SUCCEEDED(res)) {
-		printf("Unable to close cursr\n");
+		fprintf(stderr, "Unable to close cursor\n");
 		CheckReturn();
-		exit(1);
 	}
 
-	if (CommandWithResult(Statement, "drop table #odbctestdata") != SQL_SUCCESS) {
-		printf("Unable to drop table #odbctestdata \n");
-		CheckReturn();
-		exit(1);
-	}
+	Command(Statement, "drop table #odbctestdata");
 
 	Disconnect();
 
diff --git a/src/odbc/unittests/t0002.c b/src/odbc/unittests/t0002.c
index 5da1784..8fa2830 100644
--- a/src/odbc/unittests/t0002.c
+++ b/src/odbc/unittests/t0002.c
@@ -1,6 +1,6 @@
 #include "common.h"
 
-static char software_version[] = "$Id: t0002.c,v 1.12 2005/06/29 07:21:24 freddy77 Exp $";
+static char software_version[] = "$Id: t0002.c,v 1.13 2008/01/29 14:30:49 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -24,53 +24,42 @@ main(int argc, char *argv[])
 	 * result should not disappear (required for DBD::ODBC)
 	 */
 
-	if (SQLAllocStmt(Connection, &stmt) != SQL_SUCCESS) {
-		printf("Unable to allocate statement\n");
-		CheckReturn();
-		exit(1);
-	}
+	CHK(SQLAllocStmt, (Connection, &stmt));
 
 	Command(stmt, "select * from #odbctestdata where 0=1");
 
 	if (SQLFetch(stmt) != SQL_NO_DATA) {
-		printf("Data not expected\n");
+		fprintf(stderr, "Data not expected\n");
 		exit(1);
 	}
 
 	res = SQLCloseCursor(stmt);
 	if (!SQL_SUCCEEDED(res)) {
-		printf("Unable to close cursr\n");
+		fprintf(stderr, "Unable to close cursor\n");
 		CheckReturn();
-		exit(1);
 	}
 
 	Command(Statement, "select * from #odbctestdata");
 
 	/* drop first statement .. data should not disappear */
-	if (SQLFreeStmt(stmt, SQL_DROP) != SQL_SUCCESS) {
-		printf("Error dropping??\n");
-		exit(1);
-	}
+	CHK(SQLFreeStmt, (stmt, SQL_DROP));
 
 	res = SQLFetch(Statement);
 	if (res != SQL_SUCCESS && res != SQL_SUCCESS_WITH_INFO) {
-		printf("Unable to fetch row. Drop of previous statement discard results... bad!\n");
+		fprintf(stderr, "Unable to fetch row. Drop of previous statement discard results... bad!\n");
 		CheckReturn();
-		exit(1);
 	}
 
 	res = SQLFetch(Statement);
 	if (res != SQL_NO_DATA) {
-		printf("Unable to fetch row\n");
+		fprintf(stderr, "Unable to fetch row\n");
 		CheckReturn();
-		exit(1);
 	}
 
 	res = SQLCloseCursor(Statement);
 	if (!SQL_SUCCEEDED(res)) {
-		printf("Unable to close cursr\n");
+		fprintf(stderr, "Unable to close cursr\n");
 		CheckReturn();
-		exit(1);
 	}
 
 	Command(Statement, "drop table #odbctestdata");
diff --git a/src/odbc/unittests/t0003.c b/src/odbc/unittests/t0003.c
index c36947e..d9e6640 100644
--- a/src/odbc/unittests/t0003.c
+++ b/src/odbc/unittests/t0003.c
@@ -2,7 +2,7 @@
 
 /* Test for SQLMoreResults */
 
-static char software_version[] = "$Id: t0003.c,v 1.16 2005/03/29 15:19:36 freddy77 Exp $";
+static char software_version[] = "$Id: t0003.c,v 1.17 2008/01/29 14:30:49 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void
@@ -14,17 +14,14 @@ DoTest(int prepared)
 	if (!prepared) {
 		Command(Statement, "select * from #odbctestdata select * from #odbctestdata");
 	} else {
-		if (SQLPrepare(Statement, (SQLCHAR *)"select * from #odbctestdata select * from #odbctestdata", SQL_NTS) != SQL_SUCCESS)
-			ODBC_REPORT_ERROR("SQLPrepare return failure");
-		if (SQLExecute(Statement) != SQL_SUCCESS)
-			ODBC_REPORT_ERROR("SQLExecure return failure");
+		CHK(SQLPrepare, (Statement, (SQLCHAR *)"select * from #odbctestdata select * from #odbctestdata", SQL_NTS));
+		CHK(SQLExecute, (Statement));
 	}
 
 	if (SQLFetch(Statement) != SQL_NO_DATA)
 		ODBC_REPORT_ERROR("Data not expected");
 
-	if (SQLMoreResults(Statement) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Expected another recordset");
+	CHK(SQLMoreResults, (Statement));
 	printf("Getting next recordset\n");
 
 	if (SQLFetch(Statement) != SQL_NO_DATA)
@@ -38,18 +35,14 @@ DoTest(int prepared)
 	if (!prepared) {
 		Command(Statement, "select * from #odbctestdata select * from #odbctestdata");
 	} else {
-		if (SQLPrepare(Statement, (SQLCHAR *)"select * from #odbctestdata select * from #odbctestdata", SQL_NTS) != SQL_SUCCESS)
-			ODBC_REPORT_ERROR("SQLPrepare return failure");
-		if (SQLExecute(Statement) != SQL_SUCCESS)
-			ODBC_REPORT_ERROR("SQLExecure return failure");
+		CHK(SQLPrepare, (Statement, (SQLCHAR *)"select * from #odbctestdata select * from #odbctestdata", SQL_NTS));
+		CHK(SQLExecute, (Statement));
 	}
 
-	if (SQLMoreResults(Statement) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Expected another recordset");
+	CHK(SQLMoreResults, (Statement));
 	printf("Getting next recordset\n");
 
-	if (SQLFetch(Statement) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Expecting a row");
+	CHK(SQLFetch, (Statement));
 
 	if (SQLFetch(Statement) != SQL_NO_DATA)
 		ODBC_REPORT_ERROR("Data not expected");
diff --git a/src/odbc/unittests/t0004.c b/src/odbc/unittests/t0004.c
index 60cbddb..839fa60 100644
--- a/src/odbc/unittests/t0004.c
+++ b/src/odbc/unittests/t0004.c
@@ -2,7 +2,7 @@
 
 /* Test for SQLMoreResults */
 
-static char software_version[] = "$Id: t0004.c,v 1.15 2006/03/23 14:53:44 freddy77 Exp $";
+static char software_version[] = "$Id: t0004.c,v 1.16 2008/01/29 14:30:49 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void
@@ -15,28 +15,19 @@ Test(int use_indicator)
 	strcpy(buf, "I don't exist");
 	ind = strlen(buf);
 
-	if (SQLBindParameter(Statement, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, 20, 0, buf, 128, pind) != SQL_SUCCESS) {
-		printf("Unable to bind parameter\n");
-		exit(1);
-	}
+	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, 20, 0, buf, 128, pind));
 
-	if (SQLPrepare(Statement, (SQLCHAR *) "SELECT id, name FROM master..sysobjects WHERE name = ?", SQL_NTS) != SQL_SUCCESS) {
-		printf("Unable to prepare statement\n");
-		exit(1);
-	}
+	CHK(SQLPrepare, (Statement, (SQLCHAR *) "SELECT id, name FROM master..sysobjects WHERE name = ?", SQL_NTS));
 
-	if (SQLExecute(Statement) != SQL_SUCCESS) {
-		printf("Unable to execute statement\n");
-		exit(1);
-	}
+	CHK(SQLExecute, (Statement));
 
 	if (SQLFetch(Statement) != SQL_NO_DATA) {
-		printf("Data not expected\n");
+		fprintf(stderr, "Data not expected\n");
 		exit(1);
 	}
 
 	if (SQLMoreResults(Statement) != SQL_NO_DATA) {
-		printf("Not expected another recordset\n");
+		fprintf(stderr, "Not expected another recordset\n");
 		exit(1);
 	}
 
@@ -44,23 +35,17 @@ Test(int use_indicator)
 	strcpy(buf, "sysobjects");
 	ind = strlen(buf);
 
-	if (SQLExecute(Statement) != SQL_SUCCESS) {
-		printf("Unable to execute statement\n");
-		exit(1);
-	}
+	CHK(SQLExecute, (Statement));
 
-	if (SQLFetch(Statement) != SQL_SUCCESS) {
-		printf("Data expected\n");
-		exit(1);
-	}
+	CHK(SQLFetch, (Statement));
 
 	if (SQLFetch(Statement) != SQL_NO_DATA) {
-		printf("Data not expected\n");
+		fprintf(stderr, "Data not expected\n");
 		exit(1);
 	}
 
 	if (SQLMoreResults(Statement) != SQL_NO_DATA) {
-		printf("Not expected another recordset\n");
+		fprintf(stderr, "Not expected another recordset\n");
 		exit(1);
 	}
 }
diff --git a/src/odbc/unittests/tables.c b/src/odbc/unittests/tables.c
index 011a377..671ef79 100644
--- a/src/odbc/unittests/tables.c
+++ b/src/odbc/unittests/tables.c
@@ -1,6 +1,6 @@
 #include "common.h"
 
-static char software_version[] = "$Id: tables.c,v 1.13 2007/07/03 15:13:55 freddy77 Exp $";
+static char software_version[] = "$Id: tables.c,v 1.14 2008/01/29 14:30:49 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #ifdef WIN32
@@ -15,11 +15,7 @@ static void
 ReadCol(int i)
 {
 	strcpy(output, "NULL");
-	if (SQLGetData(Statement, i, SQL_C_CHAR, output, sizeof(output), &cnamesize) != SQL_SUCCESS) {
-		printf("Unable to get data col %d\n", i);
-		CheckReturn();
-		exit(1);
-	}
+	CHK(SQLGetData, (Statement, i, SQL_C_CHAR, output, sizeof(output), &cnamesize));
 }
 
 static void
@@ -28,12 +24,9 @@ TestName(int index, const char *expected_name)
 	char name[128];
 	char buf[256];
 	SQLSMALLINT len, type;
-	SQLRETURN rc;
 
 #define NAME_TEST \
 	do { \
-		if (rc != SQL_SUCCESS) \
-			ODBC_REPORT_ERROR("SQLDescribeCol failed"); \
 		if (strcmp(name, expected_name) != 0) \
 		{ \
 			sprintf(buf, "wrong name in column %d expected '%s' got '%s'", index, expected_name, name); \
@@ -42,14 +35,14 @@ TestName(int index, const char *expected_name)
 	} while(0)
 
 	/* retrieve with SQLDescribeCol */
-	rc = SQLDescribeCol(Statement, index, (SQLCHAR *) name, sizeof(name), &len, &type, NULL, NULL, NULL);
+	CHK(SQLDescribeCol, (Statement, index, (SQLCHAR *) name, sizeof(name), &len, &type, NULL, NULL, NULL));
 	NAME_TEST;
 
 	/* retrieve with SQLColAttribute */
-	rc = SQLColAttribute(Statement, index, SQL_DESC_NAME, name, sizeof(name), &len, NULL);
+	CHK(SQLColAttribute, (Statement, index, SQL_DESC_NAME, name, sizeof(name), &len, NULL));
 	if (db_is_microsoft())
 		NAME_TEST;
-	rc = SQLColAttribute(Statement, index, SQL_DESC_LABEL, name, sizeof(name), &len, NULL);
+	CHK(SQLColAttribute, (Statement, index, SQL_DESC_LABEL, name, sizeof(name), &len, NULL));
 	NAME_TEST;
 }
 
diff --git a/src/odbc/unittests/test64.c b/src/odbc/unittests/test64.c
index f29e745..8d0dd75 100644
--- a/src/odbc/unittests/test64.c
+++ b/src/odbc/unittests/test64.c
@@ -1,13 +1,9 @@
 /* test win64 consistency */
 #include "common.h"
 
-static char software_version[] = "$Id: test64.c,v 1.3 2008/01/26 21:47:26 freddy77 Exp $";
+static char software_version[] = "$Id: test64.c,v 1.4 2008/01/29 14:30:49 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
-#define CHK(func,params) \
-	if (func params != SQL_SUCCESS) \
-		ODBC_REPORT_ERROR(#func)
-
 /*
 set ipd processed_ptr with
 SQLParamOptions/SQLSetDescField/SQL_ATTR_PARAMS_PROCESSED_PTR
diff --git a/src/odbc/unittests/timeout.c b/src/odbc/unittests/timeout.c
index a1b7385..f8a7ddf 100644
--- a/src/odbc/unittests/timeout.c
+++ b/src/odbc/unittests/timeout.c
@@ -3,27 +3,19 @@
 
 /* Test timeout of query */
 
-static char software_version[] = "$Id: timeout.c,v 1.7 2007/11/26 18:12:31 freddy77 Exp $";
+static char software_version[] = "$Id: timeout.c,v 1.8 2008/01/29 14:30:49 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void
 AutoCommit(int onoff)
 {
-	SQLRETURN ret;
-
-	ret = SQLSetConnectAttr(Connection, SQL_ATTR_AUTOCOMMIT, int2ptr(onoff), 0);
-	if (ret != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Enabling AutoCommit");
+	CHK(SQLSetConnectAttr, (Connection, SQL_ATTR_AUTOCOMMIT, int2ptr(onoff), 0));
 }
 
 static void
 EndTransaction(SQLSMALLINT type)
 {
-	SQLRETURN ret;
-
-	ret = SQLEndTran(SQL_HANDLE_DBC, Connection, type);
-	if (ret != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Can't commit transaction");
+	CHK(SQLEndTran, (SQL_HANDLE_DBC, Connection, type));
 }
 
 int
@@ -58,17 +50,12 @@ main(int argc, char *argv[])
 	Connect();
 
 	AutoCommit(SQL_AUTOCOMMIT_OFF);
-	ret = SQLSetStmtAttr(Statement, SQL_ATTR_QUERY_TIMEOUT, (SQLPOINTER) 2, 0);
-	if (ret != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Error setting timeout");
+	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_QUERY_TIMEOUT, (SQLPOINTER) 2, 0));
 
 	i = 1;
-	ret = SQLBindParameter(Statement, 1, SQL_PARAM_INPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &i, 0, NULL);
-	if (ret != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("SQLBindParameter failure");
+	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &i, 0, NULL));
 
-	if (SQLPrepare(Statement, (SQLCHAR *) "update test_timeout set t = 'bad' where n = ?", SQL_NTS) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("SQLPrepare failure");
+	CHK(SQLPrepare, (Statement, (SQLCHAR *) "update test_timeout set t = 'bad' where n = ?", SQL_NTS));
 	ret = SQLExecute(Statement);
 	if (ret != SQL_ERROR)
 		ODBC_REPORT_ERROR("SQLExecute success ??");
diff --git a/src/odbc/unittests/timeout2.c b/src/odbc/unittests/timeout2.c
index 3cded35..1c61565 100644
--- a/src/odbc/unittests/timeout2.c
+++ b/src/odbc/unittests/timeout2.c
@@ -14,17 +14,13 @@
  * Test from Ou Liu, cf "Query Time Out", 2006-08-08
  */
 
-static char software_version[] = "$Id: timeout2.c,v 1.4 2007/06/27 14:52:25 freddy77 Exp $";
+static char software_version[] = "$Id: timeout2.c,v 1.5 2008/01/29 14:30:49 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #if defined(__MINGW32__) || defined(WIN32)
 #define sleep(s) Sleep((s)*1000)
 #endif
 
-#define CHK(func,params) \
-	if (func params != SQL_SUCCESS) \
-		ODBC_REPORT_ERROR(#func)
-
 int
 main(int argc, char *argv[])
 {
diff --git a/src/odbc/unittests/timeout4.c b/src/odbc/unittests/timeout4.c
index 3738dc8..be9c6f9 100644
--- a/src/odbc/unittests/timeout4.c
+++ b/src/odbc/unittests/timeout4.c
@@ -39,7 +39,7 @@
  * prepare or execute a query. This should fail and return an error message.
  */
 
-static char software_version[] = "$Id: timeout4.c,v 1.1 2007/04/20 09:15:06 freddy77 Exp $";
+static char software_version[] = "$Id: timeout4.c,v 1.2 2008/01/29 14:30:49 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #if HAVE_FSTAT && defined(S_IFSOCK)
@@ -91,9 +91,7 @@ Test(int direct)
 		return 1;
 	}
 
-	ret = SQLSetStmtAttr(Statement, SQL_ATTR_QUERY_TIMEOUT, (SQLPOINTER) 10, SQL_IS_UINTEGER);
-	if (ret != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Error setting timeout");
+	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_QUERY_TIMEOUT, (SQLPOINTER) 10, SQL_IS_UINTEGER));
 
 	alarm(30);
 	start_time = time(NULL);
diff --git a/src/odbc/unittests/transaction.c b/src/odbc/unittests/transaction.c
index a166f63..e7b507a 100644
--- a/src/odbc/unittests/transaction.c
+++ b/src/odbc/unittests/transaction.c
@@ -1,6 +1,6 @@
 #include "common.h"
 
-static char software_version[] = "$Id: transaction.c,v 1.12 2006/08/13 13:03:19 freddy77 Exp $";
+static char software_version[] = "$Id: transaction.c,v 1.13 2008/01/29 14:30:49 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int
@@ -27,96 +27,48 @@ Test(int discard_test)
 	/* create stored proc */
 	CommandWithResult(Statement, "DROP PROCEDURE testinsert");
 
-	result = CommandWithResult(Statement, createProcedure);
-	if (result != SQL_SUCCESS) {
-		ODBC_REPORT_ERROR("Can't create proc testinsert");
-		retcode = 1;
-		goto cleanup;
-	}
+	Command(Statement, createProcedure);
 
 	/* create stored proc that generates an error */
 	CommandWithResult(Statement, "DROP PROCEDURE testerror");
 
-	result = CommandWithResult(Statement, createErrorProcedure);
-	if (result != SQL_SUCCESS) {
-		ODBC_REPORT_ERROR("Can't create proc testerror");
-		retcode = 1;
-		goto cleanup;
-	}
+	Command(Statement, createErrorProcedure);
 
 	/* Start transaction */
-	result = SQLSetConnectAttr(Connection, SQL_ATTR_AUTOCOMMIT, (void *) SQL_AUTOCOMMIT_OFF, 0);
-	if (result != SQL_SUCCESS) {
-		ODBC_REPORT_ERROR("Can't start transaction");
-		retcode = 1;
-		goto cleanup;
-	}
+	CHK(SQLSetConnectAttr, (Connection, SQL_ATTR_AUTOCOMMIT, (void *) SQL_AUTOCOMMIT_OFF, 0));
 
 	/* Insert a value */
 	Command(Statement, "EXEC testinsert 1");
 
 	/* we should be able to read row count */
-	if (SQLRowCount(Statement, &rows) != SQL_SUCCESS) {
-		ODBC_REPORT_ERROR("Can't get row counts");
-		retcode = 1;
-		goto cleanup;
-	}
+	CHK(SQLRowCount, (Statement, &rows));
 
 	/* Commit transaction */
-	result = SQLEndTran(SQL_HANDLE_DBC, Connection, SQL_COMMIT);
-	if (result != SQL_SUCCESS) {
-		ODBC_REPORT_ERROR("Can't commit transaction");
-		retcode = 1;
-		goto cleanup;
-	}
+	CHK(SQLEndTran, (SQL_HANDLE_DBC, Connection, SQL_COMMIT));
 
 	SQLCloseCursor(Statement);
 
 	/* Start transaction */
-	result = SQLSetConnectAttr(Connection, SQL_ATTR_AUTOCOMMIT, (void *) SQL_AUTOCOMMIT_OFF, 0);
-	if (result != SQL_SUCCESS) {
-		ODBC_REPORT_ERROR("Can't start transaction");
-		retcode = 1;
-		goto cleanup;
-	}
+	CHK(SQLSetConnectAttr, (Connection, SQL_ATTR_AUTOCOMMIT, (void *) SQL_AUTOCOMMIT_OFF, 0));
 
 	/* Insert another value */
 	Command(Statement, "EXEC testinsert 2");
 
 	/* Roll back transaction */
-	result = SQLEndTran(SQL_HANDLE_DBC, Connection, SQL_ROLLBACK);
-	if (result != SQL_SUCCESS) {
-		ODBC_REPORT_ERROR("Can't roll back transaction");
-		retcode = 1;
-		goto cleanup;
-	}
+	CHK(SQLEndTran, (SQL_HANDLE_DBC, Connection, SQL_ROLLBACK));
 
 	/* TODO test row inserted */
 
-	result = SQLSetConnectAttr(Connection, SQL_ATTR_AUTOCOMMIT, (void *) SQL_AUTOCOMMIT_ON, 0);
-	if (result != SQL_SUCCESS) {
-		ODBC_REPORT_ERROR("Can't stop transaction");
-		retcode = 1;
-		goto cleanup;
-	}
+	CHK(SQLSetConnectAttr, (Connection, SQL_ATTR_AUTOCOMMIT, (void *) SQL_AUTOCOMMIT_ON, 0));
 
 	/* generate an error */
-	result = CommandWithResult(Statement, "EXEC testerror");
-	if (result != SQL_SUCCESS) {
-		ODBC_REPORT_ERROR("error: SQLExecDirect: testerror");
-		retcode = 1;
-		goto cleanup;
-	}
-	if (SQLBindCol(Statement, 1, SQL_C_SLONG, &out_buf, sizeof(out_buf), &out_len) != SQL_SUCCESS) {
-		ODBC_REPORT_ERROR("error: SQLBindCol: testerror");
-		retcode = 1;
-		goto cleanup;
-	}
+	Command(Statement, "EXEC testerror");
+	CHK(SQLBindCol, (Statement, 1, SQL_C_SLONG, &out_buf, sizeof(out_buf), &out_len));
 
 	while ((result = SQLFetch(Statement)) == SQL_SUCCESS) {
 		printf("\t%ld\n", (long int) out_buf);
 		if (out_buf != 1) {
-			printf("error: expected to select 1 got %ld\n", (long int) out_buf);
+			fprintf(stderr, "error: expected to select 1 got %ld\n", (long int) out_buf);
 			retcode = 1;
 			goto cleanup;
 		}
@@ -131,7 +83,7 @@ Test(int discard_test)
 	printf("SQLMoreResults returned %d\n", result);
 
 	if (result != SQL_ERROR) {
-		printf("SQLMoreResults should return error\n");
+		fprintf(stderr, "SQLMoreResults should return error\n");
 		retcode = 1;
 		goto cleanup;
 	}
@@ -147,7 +99,7 @@ Test(int discard_test)
 	result = SQLMoreResults(Statement);
 	printf("SQLMoreResults returned %d\n", result);
 	if (result != SQL_NO_DATA) {
-		printf("SQLMoreResults should return error");
+		fprintf(stderr, "SQLMoreResults should return error");
 		retcode = 1;
 		goto cleanup;
 	}
@@ -163,26 +115,19 @@ Test(int discard_test)
 int
 main(int argc, char *argv[])
 {
-	int result;
 	int retcode = 0;
 
 	Connect();
 
 	/* create table */
 	CommandWithResult(Statement, "DROP TABLE TestTransaction");
-	result = CommandWithResult(Statement, "CREATE TABLE TestTransaction ( value INT )");
-	if (result != SQL_SUCCESS) {
-		ODBC_REPORT_ERROR("Can't create table TestTransaction");
-		retcode = 1;
-		goto cleanup;
-	}
+	Command(Statement, "CREATE TABLE TestTransaction ( value INT )");
 
 	if (!retcode)
 		retcode = Test(1);
 	if (!retcode)
 		retcode = Test(0);
 
-      cleanup:
 	/* drop table */
 	CommandWithResult(Statement, "DROP TABLE TestTransaction");
 
diff --git a/src/odbc/unittests/typeinfo.c b/src/odbc/unittests/typeinfo.c
index cae15e5..c9539c9 100644
--- a/src/odbc/unittests/typeinfo.c
+++ b/src/odbc/unittests/typeinfo.c
@@ -1,6 +1,6 @@
 #include "common.h"
 
-static char software_version[] = "$Id: typeinfo.c,v 1.8 2007/07/03 15:13:55 freddy77 Exp $";
+static char software_version[] = "$Id: typeinfo.c,v 1.9 2008/01/29 14:30:49 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void
@@ -9,12 +9,9 @@ TestName(int index, const char *expected_name)
 	char name[128];
 	char buf[256];
 	SQLSMALLINT len, type;
-	SQLRETURN rc;
 
 #define NAME_TEST \
 	do { \
-		if (rc != SQL_SUCCESS) \
-			ODBC_REPORT_ERROR("SQLDescribeCol failed"); \
 		if (strcmp(name, expected_name) != 0) \
 		{ \
 			sprintf(buf, "wrong name in column %d expected '%s' got '%s'", index, expected_name, name); \
@@ -23,14 +20,14 @@ TestName(int index, const char *expected_name)
 	} while(0)
 
 	/* retrieve with SQLDescribeCol */
-	rc = SQLDescribeCol(Statement, index, (SQLCHAR *) name, sizeof(name), &len, &type, NULL, NULL, NULL);
+	CHK(SQLDescribeCol, (Statement, index, (SQLCHAR *) name, sizeof(name), &len, &type, NULL, NULL, NULL));
 	NAME_TEST;
 
 	/* retrieve with SQLColAttribute */
-	rc = SQLColAttribute(Statement, index, SQL_DESC_NAME, name, sizeof(name), &len, NULL);
+	CHK(SQLColAttribute, (Statement, index, SQL_DESC_NAME, name, sizeof(name), &len, NULL));
 	if (db_is_microsoft())
 		NAME_TEST;
-	rc = SQLColAttribute(Statement, index, SQL_DESC_LABEL, name, sizeof(name), &len, NULL);
+	CHK(SQLColAttribute, (Statement, index, SQL_DESC_LABEL, name, sizeof(name), &len, NULL));
 	NAME_TEST;
 }
 
